/** ---------------------------------------------------------------------
 * @file    main.c
 * @brief   USBL[{[hTv
 * @author  ߂ ߂遗€˂Ƌl(http://yaginet.seesaa.net/)
 * @date    2011-08-24
 * 
 ------------------------------------------------------------------------*/
#include <p30f3012.h>
#include <timer.h>
#include <stdio.h>
#include <string.h>
#include "typedef.h"
#include "usb.h"

#if 1
#include "uart.h"
#define  USE_UART
#endif

/* RtBO */
_FOSC(CSW_FSCM_OFF & XT_PLL8);
_FWDT(WDT_OFF);
_FBORPOR(MCLR_EN &PBOR_OFF);
_FGS(CODE_PROT_OFF);

/*--------------------------------------------------
* }N
*--------------------------------------------------*/

/* ݃C^[o 1msec */
/*
(1.0 * 10 ** -3) * (6.0 * 10 ** 6 * 8 / 4) - 1
*/
#define INT_INTERVAL    0x2EDF  /* 1msec x 6MHz x 8{ => (0x2EDF + 1) */

/* C^vg][hC^[o 10msec */
#define READ_INTERVAL   10

/** ---------------------------------------------------------------------
 * @brief main
 * 
 * @return 
 * 
 ------------------------------------------------------------------------*/
int main(void)
{
    USHORT  cnt;       /* ǏoJE^   */
#ifdef USE_UART
    char    str[64];   /* UARTobt@ */
    char   *p;         /* ւ̃|C^ */
#endif

    /* |[gݒ */
    ADPCFG = 0xFFFF;

    LATB   = 0x0003;
    TRISB  = 0x0040;

    LATC   = 0x0000;
    TRISC  = 0xFFFF;

    LATD   = 0x0000;
    TRISD  = 0x0000;

#ifdef USE_UART
    /* UART */
    uart_init();
    uart_trans("\r\n--- init ---\r\n");
#endif

    /* ^C} */
    OpenTimer1(T1_ON & T1_GATE_OFF & T1_PS_1_1 & T1_SYNC_EXT_OFF & T1_SOURCE_INT, INT_INTERVAL);
    ConfigIntTimer1(T1_INT_PRIOR_5 & T1_INT_ON);

    /* b҂ */
    LED_ON();
    usb_wait_ms(1000);
    LED_OFF();

    while(1){
        /* SOF(EOP)̍쐬1msec̑҂ */
        usb_make_sof_pkt();
        usb_enc_nrzi(usb_bit_sof);
        usb_wait_ms(1);

        /* ڑԂȂ΃foCXo */
        if(usb_connected_stat == 0){
            usb_connect_device();
            /* ڑȂΓǏoJE^ݒ */
            if(usb_connected_stat != 0){
                cnt         = READ_INTERVAL;
                /* Mf[^Zbg */
                usb_rcv_len = 0;
#ifdef USE_UART
                /* 񃊃Zbg */
                str[0] = '\0';
                p      = str;
#endif
            }
            continue;
        }
        /* ڑԏ */

        /* ĂiD+, D-LjȂΔڑ */
        if((PORTC & 0x6000) == 0){
            usb_disconnect_device();
            continue;
        }

        /* 1msecԊuōsSOF܂EOP */
        usb_snd(usb_bit_sof);

        /* READ_INTERVAL̊ԊuɃC^vg][h */
        if(--cnt){
            /* K̉񐔂ɓBĂȂ */
            if(usb_rcv_len){
                /* Mf[^̊mF */
                usb_dec_nrzi(usb_rcv_ptr, usb_rcv_len);
                {
                    if(usb_pkt_dat[2] & 0x0F){
                        LED_ON_L();
                    }else{
                        LED_OFF_L();
                    }
                    if(usb_pkt_dat[2] & 0xF0){
                        LED_ON_R();
                    }else{
                        LED_OFF_R();
                    }
                }
                /* Mf[^Zbg */
                usb_rcv_len = 0;
#ifdef USE_UART
                p  = str;
                sprintf(p, "%02x ",  usb_pkt_dat[2]); p += 4;
                sprintf(p, "%02x ",  usb_pkt_dat[4]); p += 4;
                sprintf(p, "%02x ",  usb_pkt_dat[5]); p += 4;
                sprintf(p, "%02x ",  usb_pkt_dat[6]); p += 4;
                sprintf(p, "%02x ",  usb_pkt_dat[7]); p += 4;
                sprintf(p, "%02x ",  usb_pkt_dat[8]); p += 4;
                sprintf(p, "%02x ",  usb_pkt_dat[9]); p += 4;
                sprintf(p, "  \r\n");
                p  = str;
#endif
            }
#ifdef USE_UART
            if(*p){
                uart_trans(p);
                p += 4;
            }
#endif
            continue;
        }
        cnt = READ_INTERVAL;

        /* C^vg] */
        usb_rd(usb_bit_in, 96 - 16);
    }

    return 0;
}

