/** ---------------------------------------------------------------------
 * @file    uart.c
 * @brief   UART
 * @author  ߂ ߂遗€˂Ƌl(http://yaginet.seesaa.net/)
 * @date    2011-08-24
 * 
 ------------------------------------------------------------------------*/
#include <p30f3012.h>
#include <stdlib.h>
#include "uart.h"

/*--------------------------------------------------
* f[^
*--------------------------------------------------*/

/* M */
static USHORT rec_num    = 0U;
/* MڕW */
static USHORT rec_length = 0U;
/* Mobt@ */
static CHAR*  rec_buf    = NULL;

/*--------------------------------------------------
* ֐`
*--------------------------------------------------*/

/* UART */
void uart_init(void)
{
    /*
    (6.0 * 10 ** 6 * 8 / 4) / 16.0 / 57600 - 1
    */
    U1BRG            = 12;
    U1MODE           = 0;       /* 8bit, no parity, 1 stop bit, no flow control */
    _U1TXIP          = 4;
    U1STA            = 0;
    U1MODE           = 0x8000; /* UARTEN */
    U1STAbits.UTXEN  = 1;
    _U1RXIE          = 0;
}

/* UARTM */
void uart_trans(CHAR* p)
{
    do{
        while(U1STAbits.UTXBF);
        U1TXREG = *p++;
    }while(*p != '\0');
    while(U1STAbits.TRMT == 0);
}

/* UARTM */
void uart_receive(CHAR* p, USHORT length)
{
    rec_num    = 0U;
    rec_length = length;
    rec_buf    = p;
    _U1RXIE    = 1;
    while(_U1RXIE);
    p[length]  = '\0';
}

/* UARTMM */
void _ISRFAST _U1RXInterrupt(void)
{
    _U1RXIF = 0;
    *(rec_buf++) = U1RXREG;
    if(++rec_num >= rec_length){
        _U1RXIE  = 0;
    }
}

