/** ---------------------------------------------------------------------
 * @file    usb.h
 * @brief   t\tgUSBwb_
 * @author  ߂ ߂遗€˂Ƌl(http://yaginet.seesaa.net/)
 * @date    2011-08-24
 * 
 ------------------------------------------------------------------------*/
#ifndef USB_H_
#define USB_H_

#include "typedef.h"

/*--------------------------------------------------
* }N
*--------------------------------------------------*/

/* SYNCp^[ */
#define USB_SYNC_PAT    0x80

/* NGXg^Cv */
#define USB_HOST_TO_DEV 0x00
#define USB_DEV_TO_HOST 0x80

/* NGXgԍ */
#define USB_REQ_GET_STS 0x00
#define USB_REQ_CLR_FTR 0x01
#define USB_REQ_SET_FTR 0x03
#define USB_REQ_SET_ADR 0x05
#define USB_REQ_GET_DSC 0x06
#define USB_REQ_SET_DSC 0x07
#define USB_REQ_GET_CFG 0x08
#define USB_REQ_SET_CFG 0x09
#define USB_REQ_GET_IF  0x0A
#define USB_REQ_SET_IF  0x0B
#define USB_REQ_SYN_FRM 0x0C

/* SOF */                    /* ~PID PID  */
#define USB_PID_SOF     0xA5 /* 1010 0101 */
/* g[N */
#define USB_PID_SETUP   0x2D /* 0010 1101 */
#define USB_PID_OUT     0xE1 /* 1110 0001 */
#define USB_PID_IN      0x69 /* 0110 1001 */
/* f[^ */
#define USB_PID_DATA0   0xC3 /* 1100 0011 */
#define USB_PID_DATA1   0x4B /* 0100 1011 */
/* nhVFCN */
#define USB_PID_ACK     0xD2 /* 1101 0010 */
#define USB_PID_NAK     0x5A /* 0101 1010 */
#define USB_PID_STALL   0x1E /* 0001 1110 */


/*--------------------------------------------------
* O[oϐ錾
*--------------------------------------------------*/

/* USBڑԁilow[D+:L, D-:H] => 0x2000, full[D+:H, D-:L] => 0x4000, none[D+:L, D-:L] => 0x0000j */
extern USHORT usb_connected_stat;
/*  */
extern USHORT usb_time;

/* USBpPbgioCgf[^jobt@ */
extern UCHAR *usb_pkt_dat;
/* USBpPbg */
extern USHORT usb_pkt_len;

/* USBpPbgirbgf[^jobt@ */
extern USHORT *usb_bit_sof;
extern USHORT *usb_bit_setup;
extern USHORT *usb_bit_in;

/*--------------------------------------------------
* ֐錾i֐^}N܂ށj
*--------------------------------------------------*/

/* msecPʂł̑҂ */
void    usb_wait_ms(USHORT wait_time);

/* foCXO */
void    usb_disconnect_device(void);
/* foCXڑ */
void    usb_connect_device(void);

/* SOFpPbg쐬ilowXs[h̏ꍇCEOPpPbg̍쐬j */
void    usb_make_sof_pkt(void);
/* g[NpPbg쐬 */
void    usb_make_token_pkt(UCHAR pid, UCHAR adr, UCHAR ep);
/* nhVFCNpPbg쐬 */
void    usb_make_handshake_pkt(UCHAR pid);

/* Rg[]pPbg쐬 */
void    usb_make_ctrl_pkt(UCHAR type, UCHAR req, USHORT val, USHORT idx, USHORT len);
/* Set_AddresspPbg쐬 */
#define usb_make_set_adr_pkt(__adr__)               usb_make_ctrl_pkt(USB_HOST_TO_DEV, USB_REQ_SET_ADR, (__adr__), 0, 0)
/* Get_DescriptorpPbg쐬 */
#define usb_make_get_dsc_pkt(__type__, __len__)     usb_make_ctrl_pkt(USB_DEV_TO_HOST, USB_REQ_GET_DSC, ((USHORT)(__type__) << 8), 0, (__len__))
/* Set_ConfigurationpPbg쐬 */
#define usb_make_set_cfg_pkt(__cfg__)               usb_make_ctrl_pkt(USB_HOST_TO_DEV, USB_REQ_SET_CFG, (__cfg__), 0, 0)

/* NRZI */
void    usb_enc_nrzi(USHORT* buf);
/* NRZI */
void    usb_dec_nrzi(USHORT* buf, USHORT bit_cnt);
/* NRZIif[^ǉj */
#define usb_add_nrzi(__ptr__)           usb_enc_nrzi((USHORT*)(__ptr__) + *(USHORT*)(__ptr__) + 1)


/* M */
extern void  (*usb_snd)(USHORT*);
extern void    usb_snd_full(USHORT*);
extern void    usb_snd_low(USHORT*);

/* M */
extern void  (*usb_rcv)(USHORT);
extern void    usb_rcv_full(USHORT);
extern void    usb_rcv_low(USHORT);
extern USHORT  usb_rcv_len;
extern USHORT *usb_rcv_ptr;

/* USB Read */
extern void  (*usb_rd)(USHORT*, USHORT);
extern void    usb_rd_full(USHORT*, USHORT);
extern void    usb_rd_low(USHORT*, USHORT);

/* USB Write */
extern void  (*usb_wr)(USHORT*, USHORT);
extern void    usb_wr_full(USHORT*, USHORT);
extern void    usb_wr_low(USHORT*, USHORT);

/* LED}N */
#define LED_ON()        { PORTB &= 0xFFFC; }
#define LED_ON_R()      { PORTB &= 0xFFFD; }
#define LED_ON_L()      { PORTB &= 0xFFFE; }
#define LED_OFF()       { PORTB |= 0x0003; }
#define LED_OFF_R()     { PORTB |= 0x0002; }
#define LED_OFF_L()     { PORTB |= 0x0001; }


#endif /* USB_H_ */

